Index: LMDZ5/branches/testing/libf/phylmd/Dust/spla_output_write.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/spla_output_write.h	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/spla_output_write.h	(revision 2641)
@@ -0,0 +1,240 @@
+!! Output SPLA
+! JE20141223
+      IF(ok_chimeredust) CALL histwrite_phy(o_m1dflux,m1dflux)
+      IF(ok_chimeredust) CALL histwrite_phy(o_m2dflux,m2dflux)
+      IF(ok_chimeredust) CALL histwrite_phy(o_m3dflux,m3dflux)
+! traceur
+
+      CALL histwrite_phy( o_taue550          , diff_aod550_tot          )
+      CALL histwrite_phy( o_taue670          , diag_aod670_tot   )
+      CALL histwrite_phy( o_taue865          , diag_aod865_tot  ) 
+      IF(id_fine>0) CALL histwrite_phy( o_taue550_tr2      , diff_aod550_tr2  )
+      IF(id_fine>0) CALL histwrite_phy( o_taue670_tr2      , diag_aod670_tr2   )
+      IF(id_fine>0) CALL histwrite_phy( o_taue865_tr2      , diag_aod865_tr2  )
+      IF(id_coss>0) CALL histwrite_phy( o_taue550_ss       , diag_aod550_ss       )
+      IF(id_coss>0) CALL histwrite_phy( o_taue670_ss       , diag_aod670_ss   )
+      IF(id_coss>0) CALL histwrite_phy( o_taue865_ss       , diag_aod865_ss    )
+      IF(id_codu>0) CALL histwrite_phy( o_taue550_dust     , diag_aod550_dust   )
+      IF(id_codu>0) CALL histwrite_phy( o_taue670_dust     , diag_aod670_dust )
+      IF(id_codu>0) CALL histwrite_phy( o_taue865_dust     , diag_aod865_dust )
+      IF(id_scdu>0) CALL histwrite_phy( o_taue550_dustsco  , diag_aod550_dustsco )
+      IF(id_scdu>0) CALL histwrite_phy( o_taue670_dustsco  , diag_aod670_dustsco )
+      IF(id_scdu>0) CALL histwrite_phy( o_taue865_dustsco  , diag_aod865_dustsco )
+      CALL histwrite_phy( o_taue550_aqua     , aod550_aqua  )
+      CALL histwrite_phy( o_taue550_terra    , aod550_terra    )
+      CALL histwrite_phy( o_taue670_aqua     , aod670_aqua     )
+      CALL histwrite_phy( o_taue670_terra    , aod670_terra    )
+      CALL histwrite_phy( o_taue865_aqua     , aod865_aqua    )
+      CALL histwrite_phy( o_taue865_terra    , aod865_terra    )
+
+      IF(id_fine>0) CALL histwrite_phy( o_taue550_fine_aqua     ,aod550_tr2_aqua   )
+      IF(id_fine>0) CALL histwrite_phy( o_taue670_fine_aqua     ,aod670_tr2_aqua   )
+      IF(id_fine>0) CALL histwrite_phy( o_taue865_fine_aqua     ,aod865_tr2_aqua   )
+      IF(id_coss>0) CALL histwrite_phy( o_taue550_coss_aqua      ,aod550_ss_aqua    )
+      IF(id_coss>0) CALL histwrite_phy( o_taue670_coss_aqua      ,aod670_ss_aqua    )
+      IF(id_coss>0) CALL histwrite_phy( o_taue865_coss_aqua      ,aod865_ss_aqua    )
+      IF(id_codu>0) CALL histwrite_phy( o_taue550_codu_aqua    ,aod550_dust_aqua    )
+      IF(id_codu>0) CALL histwrite_phy( o_taue670_codu_aqua    ,aod670_dust_aqua    )
+      IF(id_codu>0) CALL histwrite_phy( o_taue865_codu_aqua    ,aod865_dust_aqua    )
+      IF(id_scdu>0) CALL histwrite_phy( o_taue670_scdu_aqua ,aod670_dustsco_aqua    )
+      IF(id_scdu>0) CALL histwrite_phy( o_taue550_scdu_aqua ,aod550_dustsco_aqua    )
+      IF(id_scdu>0) CALL histwrite_phy( o_taue865_scdu_aqua ,aod865_dustsco_aqua    )
+      
+      IF(id_fine>0) CALL histwrite_phy( o_taue550_fine_terra     ,aod550_tr2_terra   )
+      IF(id_fine>0) CALL histwrite_phy( o_taue670_fine_terra     ,aod670_tr2_terra   )
+      IF(id_fine>0) CALL histwrite_phy( o_taue865_fine_terra     ,aod865_tr2_terra   )
+      IF(id_coss>0) CALL histwrite_phy( o_taue550_coss_terra      ,aod550_ss_terra    )
+      IF(id_coss>0) CALL histwrite_phy( o_taue670_coss_terra      ,aod670_ss_terra    )
+      IF(id_coss>0) CALL histwrite_phy( o_taue865_coss_terra      ,aod865_ss_terra    )
+      IF(id_codu>0) CALL histwrite_phy( o_taue550_codu_terra    ,aod550_dust_terra    )
+      IF(id_codu>0) CALL histwrite_phy( o_taue670_codu_terra    ,aod670_dust_terra    )
+      IF(id_codu>0) CALL histwrite_phy( o_taue865_codu_terra    ,aod865_dust_terra    )
+      IF(id_scdu>0) CALL histwrite_phy( o_taue670_scdu_terra ,aod670_dustsco_terra    )
+      IF(id_scdu>0) CALL histwrite_phy( o_taue550_scdu_terra ,aod550_dustsco_terra    )
+      IF(id_scdu>0) CALL histwrite_phy( o_taue865_scdu_terra ,aod865_dustsco_terra    )
+
+
+      IF(id_prec>0) CALL histwrite_phy( o_trm01 , trm01 )
+      IF(id_fine>0) CALL histwrite_phy( o_trm02 , trm02 )
+      IF(id_coss>0) CALL histwrite_phy( o_trm03 , trm03 )
+      IF(id_codu>0) CALL histwrite_phy( o_trm04 , trm04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_trm05 , trm05 )
+      IF(id_prec>0) CALL histwrite_phy( o_sconc01 , sconc01 )
+      IF(id_fine>0) CALL histwrite_phy( o_sconc02 , sconc02 )
+      IF(id_coss>0) CALL histwrite_phy( o_sconc03 , sconc03 )
+      IF(id_codu>0) CALL histwrite_phy( o_sconc04 , sconc04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_sconc05 , sconc05 )
+
+! Lessivage
+
+      IF(id_prec>0) CALL histwrite_phy( o_flux01       , flux01 )
+      IF(id_fine>0) CALL histwrite_phy( o_flux02       , flux02 )
+      IF(id_coss>0) CALL histwrite_phy( o_flux03       , flux03 )
+      IF(id_codu>0) CALL histwrite_phy( o_flux04       , flux04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_flux05       , flux05 )
+      IF(id_prec>0) CALL histwrite_phy( o_ds01         , ds01 )
+      IF(id_fine>0) CALL histwrite_phy( o_ds02         , ds02 )
+      IF(id_coss>0) CALL histwrite_phy( o_ds03         , ds03 )
+      IF(id_codu>0) CALL histwrite_phy( o_ds04         , ds04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_ds05         , ds05 )
+      IF(id_prec>0) CALL histwrite_phy( o_dh01         , dh01 )
+      IF(id_fine>0) CALL histwrite_phy( o_dh02         , dh02 )
+      IF(id_coss>0) CALL histwrite_phy( o_dh03         , dh03 )
+      IF(id_codu>0) CALL histwrite_phy( o_dh04         , dh04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_dh05         , dh05 )
+      IF(id_prec>0) CALL histwrite_phy( o_dtrconv01    , dtrconv01 )
+      IF(id_fine>0) CALL histwrite_phy( o_dtrconv02    , dtrconv02 )
+      IF(id_coss>0) CALL histwrite_phy( o_dtrconv03    , dtrconv03 )
+      IF(id_codu>0) CALL histwrite_phy( o_dtrconv04    , dtrconv04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_dtrconv05    , dtrconv05 )
+      IF(id_prec>0) CALL histwrite_phy( o_dtherm01     , dtherm01 )
+      IF(id_fine>0) CALL histwrite_phy( o_dtherm02     , dtherm02 )
+      IF(id_coss>0) CALL histwrite_phy( o_dtherm03     , dtherm03 )
+      IF(id_codu>0) CALL histwrite_phy( o_dtherm04     , dtherm04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_dtherm05     , dtherm05 )
+      IF(id_prec>0) CALL histwrite_phy( o_dhkecv01     , dhkecv01 )
+      IF(id_fine>0) CALL histwrite_phy( o_dhkecv02     , dhkecv02 )
+      IF(id_coss>0) CALL histwrite_phy( o_dhkecv03     , dhkecv03 )
+      IF(id_codu>0) CALL histwrite_phy( o_dhkecv04     , dhkecv04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_dhkecv05     , dhkecv05 )
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_ds01     , d_tr_ds01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_ds02     , d_tr_ds02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_ds03     , d_tr_ds03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_ds04     , d_tr_ds04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_ds05     , d_tr_ds05 )
+      IF(id_prec>0) CALL histwrite_phy( o_dhkelsc01    , dhkelsc01 )
+      IF(id_fine>0) CALL histwrite_phy( o_dhkelsc02    , dhkelsc02 )
+      IF(id_coss>0) CALL histwrite_phy( o_dhkelsc03    , dhkelsc03 )
+      IF(id_codu>0) CALL histwrite_phy( o_dhkelsc04    , dhkelsc04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_dhkelsc05    , dhkelsc05 )
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_cv01    , d_tr_cv01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_cv02    , d_tr_cv02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_cv03    , d_tr_cv03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_cv04    , d_tr_cv04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_cv05    , d_tr_cv05 )
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_trsp01  , d_tr_trsp01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_trsp02  , d_tr_trsp02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_trsp03  , d_tr_trsp03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_trsp04  , d_tr_trsp04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_trsp05  , d_tr_trsp05 )
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_sscav01 , d_tr_sscav01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_sscav02 , d_tr_sscav02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_sscav03 , d_tr_sscav03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_sscav04 , d_tr_sscav04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_sscav05 , d_tr_sscav05 )
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_sat01   , d_tr_sat01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_sat02   , d_tr_sat02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_sat03   , d_tr_sat03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_sat04   , d_tr_sat04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_sat05   , d_tr_sat05 )
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_uscav01 , d_tr_uscav01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_uscav02 , d_tr_uscav02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_uscav03 , d_tr_uscav03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_uscav04 , d_tr_uscav04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_uscav05 , d_tr_uscav05 )
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_insc01 , d_tr_insc01 ) !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_insc02 , d_tr_insc02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_insc03 , d_tr_insc03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_insc04 , d_tr_insc04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_insc05 , d_tr_insc05 )
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_bcscav01 , d_tr_bcscav01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_bcscav02 , d_tr_bcscav02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_bcscav03 , d_tr_bcscav03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_bcscav04 , d_tr_bcscav04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_bcscav05 , d_tr_bcscav05 )
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_evapls01 , d_tr_evapls01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_evapls02 , d_tr_evapls02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_evapls03 , d_tr_evapls03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_evapls04 , d_tr_evapls04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_evapls05 , d_tr_evapls05 )
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_ls01 , d_tr_ls01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_ls02 , d_tr_ls02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_ls03 , d_tr_ls03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_ls04 , d_tr_ls04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_ls05 , d_tr_ls05 )  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      
+
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_dyn01 , d_tr_dyn01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_dyn02 , d_tr_dyn02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_dyn03 , d_tr_dyn03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_dyn04 , d_tr_dyn04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_dyn05 , d_tr_dyn05 )  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_cl01 , d_tr_cl01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_cl02 , d_tr_cl02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_cl03 , d_tr_cl03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_cl04 , d_tr_cl04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_cl05 , d_tr_cl05 )  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      IF(id_prec>0) CALL histwrite_phy( o_d_tr_th01 , d_tr_th01 )
+      IF(id_fine>0) CALL histwrite_phy( o_d_tr_th02 , d_tr_th02 )
+      IF(id_coss>0) CALL histwrite_phy( o_d_tr_th03 , d_tr_th03 )
+      IF(id_codu>0) CALL histwrite_phy( o_d_tr_th04 , d_tr_th04 )
+      IF(id_scdu>0) CALL histwrite_phy( o_d_tr_th05 , d_tr_th05 )  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+
+      IF(id_coss>0) CALL histwrite_phy( o_sed_ss , sed_ss)
+      IF(id_codu>0) CALL histwrite_phy( o_sed_dust , sed_dust)
+      IF(id_scdu>0) CALL histwrite_phy( o_sed_dustsco , sed_dustsco)
+      IF(id_prec>0) CALL histwrite_phy( o_g2p_gas , his_g2pgas )
+      IF(id_fine>0) CALL histwrite_phy( o_g2p_aer , his_g2paer)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      IF(id_coss>0) CALL histwrite_phy( o_sed_ss3D , sed_ss3D)
+      IF(id_codu>0) CALL histwrite_phy( o_sed_dust3D , sed_dust3D)
+      IF(id_scdu>0) CALL histwrite_phy( o_sed_dustsco3D , sed_dustsco3D)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! histrac_spl
+!
+      CALL histwrite_phy( o_fluxbb              , fluxbb               )
+      CALL histwrite_phy( o_fluxff              , fluxff               )
+      CALL histwrite_phy( o_fluxbcbb            , fluxbcbb             )
+      CALL histwrite_phy( o_fluxbcff            , fluxbcff             )
+      CALL histwrite_phy( o_fluxbcnff           , fluxbcnff            )
+      CALL histwrite_phy( o_fluxbcba            , fluxbcba             )
+      CALL histwrite_phy( o_fluxbc              , fluxbc               )
+      CALL histwrite_phy( o_fluxombb            , fluxombb             )
+      CALL histwrite_phy( o_fluxomff            , fluxomff             )
+      CALL histwrite_phy( o_fluxomnff           , fluxomnff            )
+      CALL histwrite_phy( o_fluxomba            , fluxomba             )
+      CALL histwrite_phy( o_fluxomnat           , fluxomnat            )
+      CALL histwrite_phy( o_fluxom              , fluxom               )
+      CALL histwrite_phy( o_fluxh2sff           , fluxh2sff            )
+      CALL histwrite_phy( o_fluxh2snff          , fluxh2snff           )
+      CALL histwrite_phy( o_fluxso2ff           , fluxso2ff            )
+      CALL histwrite_phy( o_fluxso2nff          , fluxso2nff           )
+      CALL histwrite_phy( o_fluxso2bb           , fluxso2bb            )
+      CALL histwrite_phy( o_fluxso2vol          , fluxso2vol           )
+      CALL histwrite_phy( o_fluxso2ba           , fluxso2ba            )
+      CALL histwrite_phy( o_fluxso2             , fluxso2              )
+      CALL histwrite_phy( o_fluxso4ff           , fluxso4ff            )
+      CALL histwrite_phy( o_fluxso4nff          , fluxso4nff           )
+      CALL histwrite_phy( o_fluxso4bb           , fluxso4bb            )
+      CALL histwrite_phy( o_fluxso4ba           , fluxso4ba            )
+      CALL histwrite_phy( o_fluxso4             , fluxso4              )
+      CALL histwrite_phy( o_fluxdms             , fluxdms              )
+      CALL histwrite_phy( o_fluxh2sbio          , fluxh2sbio           )
+      CALL histwrite_phy( o_fluxdustec          , fluxdustec           )
+      CALL histwrite_phy( o_fluxddfine          , fluxddfine           )
+      CALL histwrite_phy( o_fluxddcoa           , fluxddcoa            )
+      CALL histwrite_phy( o_fluxddsco           , fluxddsco            )
+      CALL histwrite_phy( o_fluxdd              , fluxdd               )
+      CALL histwrite_phy( o_fluxssfine          , fluxssfine           )
+      CALL histwrite_phy( o_fluxsscoa           , fluxsscoa            )
+      CALL histwrite_phy( o_fluxss              , fluxss               )
+      CALL histwrite_phy( o_flux_sparam_ind     , flux_sparam_ind      )
+      CALL histwrite_phy( o_flux_sparam_bb      , flux_sparam_bb       )
+      CALL histwrite_phy( o_flux_sparam_ff      , flux_sparam_ff       )
+      CALL histwrite_phy( o_flux_sparam_ddfine  , flux_sparam_ddfine   )
+      CALL histwrite_phy( o_flux_sparam_ddcoa   , flux_sparam_ddcoa    )
+      CALL histwrite_phy( o_flux_sparam_ddsco   , flux_sparam_ddsco    )
+      CALL histwrite_phy( o_flux_sparam_ssfine  , flux_sparam_ssfine   )
+      CALL histwrite_phy( o_flux_sparam_sscoa   , flux_sparam_sscoa    )
+      CALL histwrite_phy( o_u10m_ss             , u10m_ss              )
+      CALL histwrite_phy( o_v10m_ss             , v10m_ss              )
+
+!      CALL histwrite_phy(  ,)
+!
+
+
+
+
Index: LMDZ5/branches/testing/libf/phylmd/Dust/tiedqneg.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/tiedqneg.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/tiedqneg.F	(revision 2641)
@@ -0,0 +1,66 @@
+      SUBROUTINE tiedqneg (pres_h,q,d_q)
+c
+      USE dimphy
+      IMPLICIT none
+c======================================================================
+c Auteur(s): CG (LGGE/CNRS) date: 19950201
+c            O. Boucher (LOA/CNRS) date 19961125
+c Objet:  Correction eventuelle des valeurs negatives d'humidite
+c induites par le schema de convection de Tiedke 
+c======================================================================
+c Arguments:
+c pres_h--input-R-la valeur de la pression aux interfaces
+c q-------input-R-quantite de traceur
+c d_q-----input-output-R-increment du traceur
+c======================================================================
+c
+#include "dimensions.h"
+c #include "dimphy.h"
+      REAL pres_h(klon,klev+1)
+      REAL q(klon,klev)
+      REAL d_q(klon,klev)
+      INTEGER nb_neg
+      INTEGER i, l
+c
+      REAL qmin
+      PARAMETER (qmin=0.0)
+c
+      DO l = klev,2,-1
+        nb_neg = 0
+        DO i = 1,klon
+          IF (q(i,l)+d_q(i,l).LT.qmin) THEN 
+          nb_neg = nb_neg + 1
+          d_q(i,l-1) = d_q(i,l-1) + (q(i,l)+d_q(i,l)-qmin)
+     .       *(pres_h(i,l)-pres_h(i,l+1))/(pres_h(i,l-1)-pres_h(i,l))
+            d_q(i,l) = qmin - q(i,l)
+          ENDIF
+        ENDDO
+c        IF (nb_neg.NE.0) THEN 
+c        PRINT *,'niveau ', l,' ' , nb_neg, ' valeurs negatives'
+c        ENDIF
+      ENDDO
+c
+      DO l = 1, klev-1
+        nb_neg = 0
+        DO i = 1,klon
+          IF (q(i,l)+d_q(i,l).LT.qmin) THEN
+          nb_neg = nb_neg + 1
+          d_q(i,l+1) = d_q(i,l+1) + (q(i,l)+d_q(i,l)-qmin)
+     .      *(pres_h(i,l)-pres_h(i,l+1))/(pres_h(i,l+1)-pres_h(i,l+2))
+          d_q(i,l) = qmin - q(i,l)
+          ENDIF
+        ENDDO
+c        IF (nb_neg.NE.0) THEN 
+c        PRINT *,'niveau ', l,' ' , nb_neg, ' valeurs negatives'
+c        ENDIF
+      ENDDO
+c
+      l = klev
+      DO i = 1,klon
+        IF (q(i,l)+d_q(i,l).LT.qmin) THEN 
+          d_q(i,l) = qmin - q(i,l)
+        ENDIF
+      ENDDO
+c
+      RETURN
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/trconvect.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/trconvect.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/trconvect.F	(revision 2641)
@@ -0,0 +1,114 @@
+c Subroutine that computes the convective mixing and transport
+      SUBROUTINE trconvect(pplay,t_seri,pdtphys,pmfu,pmfd,pen_u,pde_u,
+     .          pen_d,pde_d,paprs,zdz,xconv,qmin,qmax,lminmax,masse,
+     .                                                dtrconv,tr_seri)
+
+      USE dimphy
+      USE infotrac
+      USE indice_sol_mod
+
+      IMPLICIT NONE
+
+#include "dimensions.h"
+#include "chem.h"
+#include "YOMCST.h"
+#include "paramet.h"
+
+c============================= INPUT ===================================
+      REAL qmin, qmax
+      REAL xconv(nbtr), masse(nbtr)
+      REAL pplay(klon,klev)    ! pression pour le mileu de chaque couche (en Pa)
+      REAL t_seri(klon,klev)   ! temperature       
+      REAL zdz(klon,klev)      ! zdz
+      REAL paprs(klon,klev+1)  ! pression pour chaque inter-couche (en Pa)
+      REAL pmfu(klon,klev)     ! flux de masse dans le panache montant
+      REAL pmfd(klon,klev)     ! flux de masse dans le panache descendant
+      REAL pen_u(klon,klev)    ! flux entraine dans le panache montant
+      REAL pde_u(klon,klev)    ! flux detraine dans le panache montant
+      REAL pen_d(klon,klev)    ! flux entraine dans le panache descendant
+      REAL pde_d(klon,klev)    ! flux detraine dans le panache descendant  
+      LOGICAL lminmax
+      REAL pdtphys
+c============================= OUTPUT ==================================
+      REAL aux_var1(klon,klev)
+      REAL aux_var2(klon,klev)
+      REAL tr_seri(klon,klev,nbtr) ! traceur
+      REAL dtrconv(klon,nbtr) ! traceur
+c========================= LOCAL VARIABLES =============================
+      INTEGER it, k, i, j
+      REAL d_tr(klon,klev,nbtr)
+
+      EXTERNAL nflxtr, tiedqneg, minmaxqfi
+      
+      DO it=1, nbtr
+c
+      DO i=1, klon
+        dtrconv(i,it)=0.0
+      ENDDO
+      DO i=1,klon
+      DO j=1,klev
+        aux_var1(i,j)=tr_seri(i,j,it)
+        aux_var2(i,j)=d_tr(i,j,it)
+      ENDDO
+      ENDDO
+                                                 
+c
+cnhl      CALL nflxtr(pdtphys, pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
+cnhl     .            pplay, paprs, tr_seri(1,1,it), d_tr(1,1,it) )
+      CALL nflxtr(pdtphys, pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
+     .            pplay, paprs, aux_var1, aux_var2 )
+c
+      CALL tiedqneg(paprs,aux_var1, aux_var2)
+cnhl      CALL tiedqneg(paprs,tr_seri(1,1,it), d_tr(1,1,it))
+      DO i=1,klon
+      DO j=1,klev
+        tr_seri(i,j,it)=aux_var1(i,j)
+        d_tr(i,j,it)=aux_var2(i,j)
+      ENDDO
+      ENDDO
+c
+      DO k = 1, klev
+      DO i = 1, klon
+        IF (d_tr(i,k,it).LT.0.) THEN
+          tr_seri(i,k,it)=tr_seri(i,k,it)+d_tr(i,k,it)
+        ELSE
+          tr_seri(i,k,it)=tr_seri(i,k,it)+d_tr(i,k,it)*xconv(it)
+        ENDIF
+      ENDDO
+      ENDDO
+c
+cnhl      CALL kg_to_cm3(pplay,t_seri,d_tr(1,1,it))
+      CALL kg_to_cm3(pplay,t_seri,aux_var2)
+      DO i=1,klon
+      DO j=1,klev
+        d_tr(i,j,it)=aux_var2(i,j)
+      ENDDO
+      ENDDO
+
+      DO k = 1, klev
+      DO i = 1, klon
+        IF (d_tr(i,k,it).GE.0.) THEN
+        dtrconv(i,it)=dtrconv(i,it)+(1.-xconv(it))*d_tr(i,k,it)
+     .                /RNAVO*masse(it)*1.e3*1.e6*zdz(i,k)/pdtphys
+        ENDIF
+      ENDDO
+      ENDDO
+
+      IF (lminmax) THEN
+        DO i=1,klon
+        DO j=1,klev
+          aux_var1(i,j)=tr_seri(i,j,it)
+        ENDDO
+        ENDDO
+        CALL minmaxqfi(aux_var1,qmin,qmax,'apr convection')
+cnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'apr convection')
+        DO i=1,klon
+        DO j=1,klev
+          tr_seri(i,j,it)=aux_var1(i,j)
+        ENDDO
+        ENDDO
+      ENDIF
+c
+      ENDDO
+
+      END
Index: LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90	(revision 2641)
@@ -1,3 +1,3 @@
-SUBROUTINE add_pbl_tend(zdu, zdv, zdt, zdq, zdql, zdqi, paprs, text,abortphy)
+SUBROUTINE add_pbl_tend(zdu, zdv, zdt, zdq, zdql, zdqi, paprs, text,abortphy,flag_inhib_tend)
   ! ======================================================================
   ! Ajoute les tendances de couche limite, soit determinees par la
@@ -34,4 +34,5 @@
   CHARACTER *(*) text
   REAL paprs(klon,klev+1)
+  INTEGER flag_inhib_tend ! if flag_inhib_tend != 0, tendencies are not added
 
   ! Local :
@@ -56,7 +57,7 @@
     PRINT *, ' add_pbl_tend, zzdt ', zzdt
     PRINT *, ' add_pbl_tend, zzdq ', zzdq
-    CALL add_phys_tend(zdu, zdv, zzdt, zzdq, zdql, zdqi, paprs, text,abortphy)
+    CALL add_phys_tend(zdu, zdv, zzdt, zzdq, zdql, zdqi, paprs, text,abortphy,flag_inhib_tend)
   ELSE
-    CALL add_phys_tend(zdu, zdv, zdt, zdq, zdql, zdqi, paprs, text,abortphy)
+    CALL add_phys_tend(zdu, zdv, zdt, zdq, zdql, zdqi, paprs, text,abortphy,flag_inhib_tend)
   END IF
 
Index: LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90	(revision 2641)
@@ -2,5 +2,5 @@
 ! $Id$
 !
-SUBROUTINE add_phys_tend (zdu,zdv,zdt,zdq,zdql,zdqi,paprs,text,abortphy)
+SUBROUTINE add_phys_tend (zdu,zdv,zdt,zdq,zdql,zdqi,paprs,text,abortphy,flag_inhib_tend)
 !======================================================================
 ! Ajoute les tendances des variables physiques aux variables 
@@ -20,4 +20,5 @@
 USE geometry_mod, ONLY: longitude_deg, latitude_deg
 USE print_control_mod, ONLY: prt_level
+USE cmp_seri_mod
 IMPLICIT none
   include "YOMCST.h"
@@ -31,4 +32,5 @@
 CHARACTER*(*) text
 INTEGER abortphy
+INTEGER flag_inhib_tend ! if flag_inhib_tend != 0, tendencies are not added
 
 ! Local :
@@ -55,5 +57,20 @@
 ! Initialisations
 
-      IF (abortphy==1) RETURN ! on n ajoute pas les tendance si le modele
+     IF (prt_level >= 5) then
+        write (*,*) "In add_phys_tend, after ",text
+        call flush
+     end if
+
+     ! if flag_inhib_tend != 0, tendencies are not added
+     IF (flag_inhib_tend /= 0) then
+        ! If requiered, diagnostics are shown
+        IF (flag_inhib_tend > 0) then
+           ! print some diagnostics if xxx_seri have changed
+           call cmp_seri(flag_inhib_tend,text)
+        END IF
+        RETURN ! on n ajoute pas les tendance
+     END IF
+
+     IF (abortphy==1) RETURN ! on n ajoute pas les tendance si le modele
                               ! a deja plante.
 
@@ -259,4 +276,4 @@
 
 
-      RETURN
-      END
+  RETURN
+END SUBROUTINE add_phys_tend
Index: LMDZ5/branches/testing/libf/phylmd/add_wake_tend.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/add_wake_tend.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/add_wake_tend.F90	(revision 2641)
@@ -0,0 +1,64 @@
+SUBROUTINE add_wake_tend(zddeltat, zddeltaq, zds, zddens, zoccur, text, abortphy)
+!===================================================================
+! Ajoute les tendances liées aux diverses parametrisations physiques aux
+! variables d'etat des poches froides.
+!===================================================================
+!======================================================================
+! Declarations
+!======================================================================
+
+USE dimphy, ONLY: klon, klev
+USE phys_state_var_mod, ONLY: wake_deltat, wake_deltaq, wake_s, wake_dens
+
+USE print_control_mod, ONLY: prt_level
+IMPLICIT none
+
+! Arguments :
+!------------
+  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: zddeltat, zddeltaq
+  REAL, DIMENSION(klon),         INTENT (IN)         :: zds, zddens
+  INTEGER, DIMENSION(klon),      INTENT (IN)         :: zoccur
+  CHARACTER*(*),                 INTENT (IN)         :: text
+  INTEGER,                       INTENT (IN)         :: abortphy
+
+! Local :
+!--------
+
+INTEGER                                              :: i, l
+
+
+
+     IF (prt_level >= 5) then
+        write (*,*) "In add_wake_tend, after ",text
+        call flush
+     end if
+
+     IF (abortphy==1) RETURN ! on n ajoute pas les tendance si le modele
+                              ! a deja plante.
+
+!======================================================================
+!    Add tendencies to wake state variables
+!======================================================================
+         DO l = 1, klev
+           DO i = 1, klon
+             IF (zoccur(i) .GE. 1) THEN
+               wake_deltat(i, l) = wake_deltat(i, l) + zddeltat(i,l)
+               wake_deltaq(i, l) = wake_deltaq(i, l) + zddeltaq(i,l)
+             ELSE
+               wake_deltat(i, l) = 0.
+               wake_deltaq(i, l) = 0.
+             ENDIF   ! (zoccur(i) .GE. 1)
+           END DO
+         END DO
+         DO i = 1, klon
+           IF (zoccur(i) .GE. 1) THEN
+             wake_s(i)    = wake_s(i)    + zds(i)
+             wake_dens(i) = wake_dens(i) + zddens(i)
+           ELSE
+             wake_s(i)    = 0.
+             wake_dens(i) = 0.
+           ENDIF   ! (zoccur(i) .GE. 1)
+         END DO
+
+RETURN
+END
